#include <iostream>
#include <numeric>
#include <set>
#include <algorithm>
#include <numeric>
#include <string>
#include <vector>

void solve() {
	int n, k;
	std::cin >> n >> k;

	std::multiset<int> d;
	for (int i = 0; i < n; ++i) {
		int x;
		std::cin >> x;
		d.insert(x);
	}

	std::vector<std::vector<int>> ans;

	while (d.size() > 0) {
		auto &v = ans.emplace_back();

		auto a = *d.begin();
		d.erase(d.begin());
		v.push_back(a);

		auto it = d.lower_bound(k - a);
		if (it != d.begin()) {
			it = prev(it);
			v.push_back(*it);
			d.erase(it);
		}

		//for (auto x : v) std::cerr << x << ' ';
		//std::cerr << '\n';
	}

	for (size_t i = 0; i < ans.size(); ++i) {
		auto sum = std::accumulate(ans[i].begin(), ans[i].end(), 0);
		if (sum < k) {
			if (d.size() == 0 && i + 1 < ans.size()) {
				for (auto x : ans.back()) d.insert(x);
				ans.pop_back();
			}
			if (d.size() > 0) {
				ans[i].push_back(*d.begin());
				d.erase(d.begin());
			}
		}
	}

	std::cout << ans.size() + d.size() - 1 << '\n';
}

int main() {
	int t;
	std::cin >> t;
	while (t--) solve();
}
